Name: charlie
Version: 0.5
Release: 1%{?dist}
Summary: Virtual CFO - a penny saved is a penny earned

Group: Network/Daemons
License: GPLv2
URL: https://www.redhat.com/
BuildRoot:    %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildArch: noarch

%description
Charlie is your own virtual CFO.  When placed on machines it will shut
down hosts that have been idle for a configrable amount of time (listed
in /etc/charlie.conf).  Idleness is determined by last logins.  By default
this package will shutdown a server that has not been logged into for 24 hours


%install
mkdir -p %{buildroot}/%{_sysconfdir}/cron.hourly %{buildroot}/%{_bindir}
cat <<EOF > %{buildroot}/%{_bindir}/charlie
#!/bin/bash

# This app will shutdown a host that is not actively being used.


# Check to make sure no one is logged in

if [ \$(who | wc -l) -gt 0 ]
then
    # People logged in
    echo "People are logged in: \$(who | wc -l)" | logger -p local0.notice -t charlie
    exit 1
fi

SAVEIFS=\$IFS
IFS=\$(echo -en "\n\b")

HOURS=24
. /etc/charlie.conf
SECONDS=\$((HOURS*60*60))

now_time=\$(date +%s)

wtmp_time=\$(ls -l --time-style="+%s" /var/log/wtmp | awk '{ print \$6 }')
diff_time=\$((\$now_time - \$wtmp_time))

if [ \$SECONDS -gt \$diff_time ]
then
    # Someone has been logged in
    exit
fi

echo "No users found in the last \$HOURS hours.  Shutting down" | logger -p local0.notice -t charlie
shutdown -h +5 "No one seems to be using the system.  Shutting down, saving money.  Thank you"
EOF

chmod +x %{buildroot}/%{_bindir}/charlie
ln -s %{_bindir}/charlie %{buildroot}/%{_sysconfdir}/cron.hourly/charlie 

cat <<EOF > %{buildroot}/%{_sysconfdir}/charlie.conf
# How many idle hours (IE: no one has been logged in since)
#  After this time, the system will shut down

HOURS=6
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/charlie.conf
%config(noreplace) %{_sysconfdir}/cron.hourly/charlie
%{_bindir}/charlie

%changelog
* Wed Jun 06 2012 Matt Hicks <mhicks@redhat.com> 0.5-1
- Switching default idle time from 24 to 6 hours

* Wed Jun 30 2011 Mike McGrath <mmcgrath@redhat.com> 0.4-1
- Adding hours to output message

* Wed Jun 30 2011 Mike McGrath <mmcgrath@redhat.com> 0.3-1
- Fixing escaped times

* Wed Jun 30 2011 Mike McGrath <mmcgrath@redhat.com> 0.2-1
- Adding shutdown message

* Wed Jun 29 2011 Mike McGrath <mmcgrath@redhat.com> 0.1-1
- Initial charlie packaging
